// Create Table

CREATE TABLE `optimizer` (
`date_time` DATETIME NOT NULL ,
`line` MEDIUMINT NOT NULL ,
`timeout` DECIMAL( 4, 2 ) NOT NULL ,
`command` MEDIUMTEXT NOT NULL 
);

ALTER TABLE `optimizer` ADD INDEX ( `line` ) ;
ALTER TABLE `optimizer` ADD INDEX ( `date_time` ) ;


// Query 1

SELECT line, AVG( timeout ) AS avg_time, SUM( timeout ) AS sum_time, COUNT( * ) AS how, command
FROM optimizer
GROUP BY line
ORDER BY avg_time DESC , sum_time DESC , how DESC 
LIMIT 100 

// Query 2

SELECT line, SUM( timeout ) AS sum_time, AVG( timeout ) AS avg_time,  COUNT( * ) AS how, command
FROM optimizer
GROUP BY line
ORDER BY sum_time DESC , avg_time DESC ,  how DESC 
LIMIT 100 
