<?php

/**
 * admin.php
 * ---------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Password check
if ( ITS_MANAGER !== true )
{
	if ( ITS_AGENT === true )
	{
		if ( md5($_POST['code']) != SEC_PASSWORD)
		{
			if ( $_POST['code'] != AGENT_PASS || strlen(AGENT_PASS) == 0 ) die("WRONG_PASSWORD");
		}
	}
	if ( ITS_SPIDER === true )
	{
		if ( md5($_POST['code']) != SEC_PASSWORD)
		{
			if ( $_POST['code'] != SPIDER_PASS || strlen(SPIDER_PASS) == 0 ) die("WRONG_PASSWORD");
		}
	}
	if ( ITS_SPIDER !== true && ITS_AGENT !== true )
	{
		if ( md5($_POST['code']) != SEC_PASSWORD) die("WRONG_PASSWORD");
	}
}

// IP test
if ( strlen(SEC_ENTER_IP) > 0 )
{
    $ips = explode(' ', SEC_ENTER_IP);
	if ( !in_array(user_ip(), $ips) ) die("IP_BLOCKED");
}

// Testing path and right for files and folders
if ( !@fopen('./tmp/test.xml', 'w') ) die("PHP_ERROR: Wrong mode for /admin/tmp, need read/write access mode");
@unlink('./tmp/test.xml');
if ( !@fopen('./../files/test.gif', 'w') ) die("PHP_ERROR: Wrong mode for /files, need read/write access mode");
@unlink('./../files/test.gif');
if ( !@fopen('./tmp/load_data.csv', 'w') ) die("PHP_ERROR: Can't rewrite file admin/tmp/load_data.csv. Please, erase it.");

/*************************************************************************************************************/

/**
 * Function zip_file_to_string
 * Unpack content of zip file to string
 **/
function zip_file_to_string($mZipFile)
{
	if ( !file_exists($mZipFile) ) die("PHP_ERROR: Don't received data file");
  	$archive = new PclZip($mZipFile);
	$files = $archive->extract(PCLZIP_OPT_EXTRACT_AS_STRING);
  	if ( count($files) <= 0 ) die("PHP_ERROR: Archive unpack error");
	return $files[0]['content'];

}

/**
 * Function xml_to_zip_answer
 * Compress xml file to zip file and echo it.
 **/
function xml_to_zip_answer($mXMLFile)
{
	// Put result to archive
	$zip_file = './tmp/'.md5(session_id()).'.zip';
	$archive = new PclZip($zip_file);
	$pack_list = $archive->create($mXMLFile, PCLZIP_OPT_REMOVE_ALL_PATH);
	if ( $pack_list == 0 ) die("PHP_ERROR: Error line [".__LINE__."] \r\n".$archive->errorInfo(true));

	// echo result
	echo "ZIP_RESULT";
	echo md5(session_id());
	echo @implode("", (@file($zip_file)));

	// erase tmp files
	@unlink($mXMLFile);
	@unlink($zip_file);
}

/**
 * Function string_to_zip_answer
 * Compress string to zip file and echo it.
 **/
function string_to_zip_answer($mString)
{
	// Put strint to temp file
	$tmp_file = './tmp/'.md5(session_id()).'.xml';
	$fh = fopen($tmp_file, "w");
	fwrite($fh, $mString, strlen($mString));
	fclose($fh);

	// Put result to archive
	$zip_file = './tmp/'.md5(session_id()).'.zip';
	$archive = new PclZip($zip_file);
	$pack_list = $archive->create($tmp_file, PCLZIP_OPT_REMOVE_ALL_PATH);
	if ( $pack_list == 0 ) die("PHP_ERROR: Error line [".__LINE__."] \r\n".$archive->errorInfo(true));

	// echo result
	echo "ZIP_RESULT";
	echo md5(session_id());
	echo @implode("", (@file($zip_file)));

	// erase tmp files
	@unlink($tmp_file);
	@unlink($zip_file);
}

/**
 * Function xml_to_array
 * Parse xml string to associative array.
 **/
function xml_to_array($mXML)
{
	$xml_parser = xml_parser_create();
	xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, FALSE);
   	xml_parse_into_struct($xml_parser, $mXML, $xml_val, $xml_tag);
   	xml_parser_free($xml_parser);

   	$res_val=array();
   	foreach ($xml_val as $t_val)
	{
   		if ($t_val['level'] == 2) $res_val[$t_val['tag']]=$t_val['value'];
   	}

   	return $res_val;
}


function xml_get_children($vals, &$i)
{
	$children = array();
   	if ( isset($vals[$i]['value']) ) $children[] = $vals[$i]['value'];
   	while ( ++$i < count($vals) )
   	{
   		if ( isset($vals[$i]['attributes']) )
   		{
   			foreach ( $vals[$i]['attributes'] as $key => $value ) $vals[$i]['attributes'][$key] = iconv("UTF-8", SHOP_CHARSET, $value);
   		}
      	switch ( $vals[$i]['type'] )
      	{
        	case 'cdata':
           		$children[] = $vals[$i]['value'];
           		break;
       		case 'complete':
           		$children[] = array('tag'        => $vals[$i]['tag'],
               						'attributes' => isset($vals[$i]['attributes']) ? $vals[$i]['attributes'] : null,
               						'value'      => $vals[$i]['value']);
           		break;
       		case 'open':
           		$children[] = array('tag'        => $vals[$i]['tag'],
               						'attributes' => isset($vals[$i]['attributes']) ? $vals[$i]['attributes'] : null,
               						'children'   => xml_get_children($vals, $i));
           		break;
       		case 'close':
       			return $children;
       }
   }
}

function xml_get_tree($mXML)
{
	$parser = xml_parser_create();
   	xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
   	xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE,   1);
   	xml_parse_into_struct($parser, $mXML, $vals, $index);
   	xml_parser_free($parser);

   	return array('tag'        => $vals[0]['tag'],
       			 'attributes' => isset($vals[0]['attributes']) ? $vals[0]['attributes'] : null,
       			 'children'   => xml_get_children($vals, $i = 0));
}



?>