<?php

/**
 * class.DataBaseODBC.php
 * ----------------------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

/** 
 * Class DataBaseODBC
 * Operate with data via ODBC SQL-queries.
 * Parent of this class is DataBase which based on MySQL SQL-queris.
 * Class have method only for special ODBC SQL-queris.
 **/
class DataBaseODBC extends DataBase
{
	/**
     * DataBaseODBC
     */
	function DataBaseODBC($mSimpleError, $mParam)
	{
		$this->DataBase($mSimpleError, $mParam);
	}
	
	/**
	 * Connect
	 **/
	function ConnectToDB($mSimpleError)
	{
		require_once(SHOP_CWD.'/admin/class/data/access/class.ODBC.php');

		$this->gDBNick = $mPrivat[db_nick];
		$this->gDB = new ODBC(basename(__FILE__), 
							  __LINE__, 
							  $this->gDBName, 
							  $this->gDBUserName,
							  $this->gDBUserPass
							  );
	}	
	

}

?>