<?php

/**
 * tables.php
 * ----------
 * @version 5.4.0
 * @copyright 2002-2010 Melbis Company
 * @link http://www.melbis.com
 * @author Dmitriy Kasyanov
 **/

// Limit size for prices, max value is 18.
// Use min value for fast work database.
$mash = 10;
 
$gTables = array(
	// topic
	array('table_name'	=> 'topic',
		  'fields' 	   	=> array('id' 			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'name' 			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'active'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'istype'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'title'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'descr'  		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'link' 			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'div_before'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'template_name'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '50',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'templates_goods'=> array('type' => 'VARCHAR',
		   									   			 'size' => '50',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'main_goods_col'=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'new_goods_col'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'new_goods_how'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'hit_goods_col'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'hit_goods_how'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'step_goods'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'sub_sec_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'keywords'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								'in_cat_left'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'in_cat_center'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'in_cat_menu'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'in_cat_down'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'link_title'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'full_descr'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'order_by_voice'=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'in_xml'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'seo_psu'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '70',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'select_name'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'select_place_type'=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'select_dir_name'=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								'cache_how_goods'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											   			 )
							   ),
		  'indexes'	   	=> array('id' 			=> 'PRIMARY KEY', 'seo_psu' => 'KEY'
								),
		  'attr'		=> ''
		 ),
	// topic_store	 
	array('table_name'	=> 'topic_store',
		  'fields' 	   	=> array('topic_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('topic_id,store_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// advert 
	array('table_name'	=> 'advert',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// topic_adv 
	array('table_name'	=> 'topic_adv',
		  'fields' 	   	=> array('topic_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'adv_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'new_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),		
								 'place_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),		
								 'place_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'dir_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'col_num'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'iscompare'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'one_time'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('topic_id,adv_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// adv_store 
	array('table_name'	=> 'adv_store',
		  'fields' 	   	=> array('adv_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('adv_id,store_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store	 
	array('table_name'	=> 'store',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'code'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'meas'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'status'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'price'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'part_proc'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'step_order'	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),																 
								 'min_order'	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'tax'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'disc_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'active'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'apendix_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'how'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'xpos'			=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'ypos'			=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'w'		  	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'h'			=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'kind'			=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'family'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price_curr_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'dprice_curr_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'disc_price_base'=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	 
								 'conf_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'seo_title'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'seo_descr'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'seo_keywords'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'seo_link'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'seo_alt'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'in_xml'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'voice_avg'	=> array('type' => 'DECIMAL',
		   									   			 'size' => '3,2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'voice_how'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'seo_psu'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '70',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'provider_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'prov_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'prov_price_base'=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'pprice_curr_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'cache_base_param'=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								 'cache_info_preview'=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								 'cache_family'	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								 'cache_param'	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								 'cache_disc'	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								 'cache_advert'	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )						  			 
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY', 'conf_id' => 'KEY', 'family' => 'KEY', 'seo_psu' => 'KEY' 
								),
		  'attr'		=> ''
		 ),		 
	// discount	 
	array('table_name'	=> 'discount',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'from_how'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'category_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'proc'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_curr_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )												  			 
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// category	 
	array('table_name'	=> 'category',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// store_disc
	array('table_name'	=> 'store_disc',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'disc_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id,disc_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// info	 
	array('table_name'	=> 'info',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'key_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'in_main'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'in_preview'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'in_family'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )											  			 	
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// info_value
	array('table_name'	=> 'info_value',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'info_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('info_id, id' 	=> 'PRIMARY KEY',
		  						 'id'			=> 'KEY'
								),
		  'attr'		=> ''
		 ),
	// store_info
	array('table_name'	=> 'store_info',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'info_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'value_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id,info_id,value_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// filters
	array('table_name'	=> 'filters',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
		  						 'info_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'place_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'values_col'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'list_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'in_firstpage'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'all_values'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'dir_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'one_more'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'no_topic_filter'=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'all_goods_page'=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('info_id, id' 		=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// topic_filter
	array('table_name'	=> 'topic_filter',
		  'fields' 	   	=> array('topic_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'info_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'values_col'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'list_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('topic_id,info_id' 		=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// topic_filter_area
	array('table_name'	=> 'topic_filter_area',
		  'fields' 	   	=> array('topic_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'area_topic_id'=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('topic_id,area_topic_id' 		=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),	
	// param
	array('table_name'	=> 'param',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'get_type'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),			
								 'dir_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),		
								 'col_num'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'xpos'			=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'ypos'			=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'w'		  	=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'h'			=> array('type' => 'SMALLINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'phis_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )		
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// param_value
	array('table_name'	=> 'param_value',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'proc'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tax'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_curr_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )											  			 
							   ),
		  'indexes'	   	=> array('param_id, id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_param
	array('table_name'	=> 'store_param',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id, param_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_add
	array('table_name'	=> 'store_add',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_value_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'code'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'status'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'tax'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price_curr_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id, param_value_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_adv 
	array('table_name'	=> 'store_adv',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'adv_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'new_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'place_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'dir_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'col_num'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'iscompare'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id, adv_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_comp 
	array('table_name'	=> 'store_comp',
		  'fields' 	   	=> array('base_store_id'=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'inc_store_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('base_store_id, inc_store_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_gift 
	array('table_name'	=> 'store_gift',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'start_sum'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'end_sum'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_new 
	array('table_name'	=> 'store_new',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_hits 
	array('table_name'	=> 'store_hits',
		  'fields' 	   	=> array('store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('store_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// text_block	 
	array('table_name'	=> 'text_block',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'content'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'in_firstpage'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'in_catalog'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'in_preview'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'in_techpage'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'place_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),		
								 'dir_name'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 )		
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// delivery
	array('table_name'	=> 'delivery',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'proc'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'free_from'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_curr_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )											  			 											  			 		
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// delivery_multiplex
	array('table_name'	=> 'delivery_multiplex',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'delivery_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tax_from'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'multiplex'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',4',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('delivery_id, id' 	=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		
	// delivery_cost
	array('table_name'	=> 'delivery_cost',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'delivery_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'sum_from'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'cost'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'cost_curr_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'cost_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('delivery_id, id' 	=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),			  
	// condition
	array('table_name'	=> 'condition',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'proc'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'multiplex_how'=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'multiplex_how_tax'=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_curr_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )											  			 											  			 		
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// payment
	array('table_name'	=> 'payment',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'curr_name'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'multiplex'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',4',
											   			 'attr' => array('UNSIGNED','NOT NULL')
											  			 ),
								 'division'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'curr_prec'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'online'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'info_type'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'pay_template'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'vat_value'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )											  			 
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// payment_delivery
	array('table_name'	=> 'payment_delivery',
		  'fields' 	   	=> array('payment_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'delivery_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('payment_id, delivery_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// discount_order
	array('table_name'	=> 'discount_order',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'from_sum'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'proc'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )										  			 										  			 
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// currency
	array('table_name'	=> 'currency',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'multiplex'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',4',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'division'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )												  			 											  			 
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// manager
	array('table_name'	=> 'manager',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '50',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'login'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pass'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email_full'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email_short'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'charset_full'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'charset_short'=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// client_field
	array('table_name'	=> 'client_field',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'need'			=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )		
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// client_field_set
	array('table_name'	=> 'client_field_set',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'client_field_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'set_value'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('client_field_id, id' 	=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// client_field_value
	array('table_name'	=> 'client_field_value',
		  'fields' 	   	=> array('client_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'client_field_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'value_text'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('client_id, client_field_id'     => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// client
	array('table_name'	=> 'client',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'login'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pass'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '32',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'proc'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'category_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'orders_suma'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'reg_date'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'last_date'	=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'charset'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'rules_allow'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )											  			 													 
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// shop_values
	array('table_name'	=> 'shop_values',
		  'fields' 	   	=> array('key_name'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '30',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'key_value'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('key_name'     => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// current_basket
	array('table_name'	=> 'current_basket',
		  'fields' 	   	=> array('id'			=> array('type' => 'BIGINT',
			   								   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'sid'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '32',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'code'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tax'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'status'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'disc_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_value_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_name'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
														 ),
								 'param_personal'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_proc'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'param_suma'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
														 ),
								 'remember'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'modify_suma'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'modify_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'meas'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'part_proc'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'prov_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'provider_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' 							=> 'PRIMARY KEY',
		  						 'sid,store_id,param_value_id'	=> 'KEY'
								),
		  'attr'		=> ''
		 ),	
	// remember
	array('table_name'	=> 'remember',
		  'fields' 	   	=> array('email'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'param_value_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
														 )
							   ),
		  'indexes'	   	=> array('email, store_id, param_value_id'	=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),			 	 
	// archive_basket
	array('table_name'	=> 'archive_basket',
		  'fields' 	   	=> array('id'			=> array('type' => 'BIGINT',
			   								   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'order_id'		=> array('type' => 'BIGINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 
								 'code'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'meas'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),					
								 'param_name'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),																 									 
								 'param_personal'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'param_value_id' 	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'price'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'new_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'status'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
														 ),
								 'part_proc'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_value'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'modify_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'prov_price'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'provider_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
														 ),
								 'tax'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 
								 'inside_disc'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )															 
							   ),
		  'indexes'	   	=> array('id' 					=> 'PRIMARY KEY',
		  						 'order_id,store_id'	=> 'KEY'
								),
		  'attr'		=> ''
		 ),		 
	// archive_order
	array('table_name'	=> 'archive_order',
		  'fields' 	   	=> array('id'			=> array('type' => 'BIGINT',
		   									   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'code'			=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),			
								 'sid'			=> array('type' => 'VARCHAR',
			   								   			 'size' => '32',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 											 
								 'client_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'manager_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 												 
								 'partner_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		
								 'status'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'disc_sum'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'cond_name'	=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'cond_cost'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),														 
								 'deliv_name' 	=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'deliv_cost' 	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),	 
								 'payment_name' => array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'payment_cost' => array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),															 			
								 'payment_curr' => array('type' => 'VARCHAR',
			   								   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),		
								 'payment_id'	=> array('type' => 'INT',														 	
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),														 			
								 'itogo_sum'    => array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'total_sum'	=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'get_payment'	=> array('type' => 'TINYINT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),		 														 
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
														 ),
								 'notice'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'partner_sum'  => array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'deliv_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'cond_code' 	=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'inside_note'	=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'update_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
														 )
							   ),
		  'indexes'	   	=> array('id' 			=> 'PRIMARY KEY',
		  						 'client_id'	=> 'KEY'
								),
		  'attr'		=> ''
		 ),		
	// archive_client_field
	array('table_name'	=> 'archive_client_field',
		  'fields' 	   	=> array('order_id'		=> array('type' => 'BIGINT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'field_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'value_text'	=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )														 	
							   ),
		  'indexes'	   	=> array('order_id,field_id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// news
	array('table_name'	=> 'news',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'		    => array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 	
								 'place_code'	=> array('type' => 'VARCHAR',
			   								   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'top_how'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'subscribe'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'rss'			=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'ishidden'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'for_buyer'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'ishtml'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'istype'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isperiod'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// news_content
	array('table_name'	=> 'news_content',
		  'fields' 	   	=> array('news_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'attach'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),				
								 'descr'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 							  			 
								 'content'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )														 	
							   ),
		  'indexes'	   	=> array('news_id, id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// subscriber
	array('table_name'	=> 'subscriber',
		  'fields' 	   	=> array('news_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'email'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'charset'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),													 	
								 'reg_date'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )												  			 
							   ),
		  'indexes'	   	=> array('news_id, email' 		=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// voting
	array('table_name'	=> 'voting',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'		    => array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 
								 'absindex'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),														 	
								 'place_code'	=> array('type' => 'VARCHAR',
			   								   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'start_date'	=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'end_date'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		
	// vote_list
	array('table_name'	=> 'vote_list',
		  'fields' 	   	=> array('vote_id'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'value_name'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'value_descr'	=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),			
								 'value_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),											  			 								  			 							  			 
								 'value_group'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),	
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )														 	
							   ),
		  'indexes'	   	=> array('vote_id, id' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// vote_pool
	array('table_name'	=> 'vote_pool',
		  'fields' 	   	=> array('vote_list_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'sid'			=> array('type' => 'VARCHAR',
			   								   			 'size' => '32',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )													 	
							   ),
		  'indexes'	   	=> array('vote_list_id, sid' => 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),		 
	// shop_stat
	array('table_name'	=> 'shop_stat',
		  'fields' 	   	=> array('sid'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '32',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ip'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'from_page'	=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'page_code'	=> array('type' => 'ENUM',
			   								   			 'size' => '"index", "dir", "goods", "descr", "buy", "order", "login", "config", "seacrh"',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'elem_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'elem_code'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
 								 'user_agent'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 )											  			 
							   ),
		  'indexes'	   	=> array('date_time' => 'KEY'),
		  'attr'		=> ''
		 ),
	// ss_visitor
	array('table_name'	=> 'ss_visitor',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isweek'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'domen'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'keyword'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('ismonth' => 'KEY', 'isweek' => 'KEY', 'isday' => 'KEY', 'domen' => 'KEY', 'keyword' => 'KEY'),
		  'attr'		=> ''
		 ),
	// ss_visitor_day
	array('table_name'	=> 'ss_visitor_day',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'viewer'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'visitor'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('isday' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// ss_visitor_week
	array('table_name'	=> 'ss_visitor_week',
		  'fields' 	   	=> array('isweek'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'viewer'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'visitor'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('isweek' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// ss_visitor_month
	array('table_name'	=> 'ss_visitor_month',
		  'fields' 	   	=> array('ismonth'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'viewer'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'visitor'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('ismonth' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// ss_topic
	array('table_name'	=> 'ss_topic',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isweek'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )											  			 
							   ),
		  'indexes'	   	=> array('ismonth' => 'KEY', 'isweek' => 'KEY', 'isday' => 'KEY', 'id' => 'KEY'),
		  'attr'		=> ''
		 ),
	// ss_store
	array('table_name'	=> 'ss_store',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isweek'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'how'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )											  			 
							   ),
		  'indexes'	   	=> array('ismonth' => 'KEY', 'isweek' => 'KEY', 'isday' => 'KEY', 'id' => 'KEY'),
		  'attr'		=> ''
		 ),
	// ss_store_buy
	array('table_name'	=> 'ss_store_buy',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isweek'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
			   								   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('ismonth' => 'KEY', 'isweek' => 'KEY', 'isday' => 'KEY', 'id' => 'KEY'),
		  'attr'		=> ''
		 ),
	// ss_search
	array('table_name'	=> 'ss_search',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'isweek'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'one_word'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '100',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'phrase'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('isday' => 'KEY', 'isweek' => 'KEY', 'ismonth' => 'KEY', 'one_word' => 'KEY'),
		  'attr'		=> ''
		 ),
	// ss_order
	array('table_name'	=> 'ss_order',
		  'fields' 	   	=> array('isweek'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),											  			 
								 'from_page'	=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'domen'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'keyword'		=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
			   								   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('isweek' => 'KEY', 'ismonth' => 'KEY', 'date_time' => 'KEY'),
		  'attr'		=> ''
		 ),
	// conf
	array('table_name'	=> 'conf',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
			   								   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'tlevel'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'tindex'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'absindex'		=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'sort_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isfolder'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// conf_unit
	array('table_name'	=> 'conf_unit',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'conf_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('conf_id, id' 	=> 'PRIMARY KEY',
		  						 'id'			=> 'KEY'
								),
		  'attr'		=> ''
		 ),
	// conf_topic
	array('table_name'	=> 'conf_topic',
		  'fields' 	   	=> array('conf_unit_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'topic_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('conf_unit_id, topic_id' 	=> 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// conf_store
	array('table_name'	=> 'conf_store',
		  'fields' 	   	=> array('conf_unit_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('conf_unit_id, store_id' 	=> 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// partner_main
	array('table_name'	=> 'partner_main',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
		  						 'rules'		=> array('type' => 'MEDIUMTEXT',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'cookie_days'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pay_days'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'active'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'no_active_days'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'save_account_years'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'stat_full_days'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'stat_days'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'stat_month'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'advert_items'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pay_suma'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pay_suma_curr_id'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pay_suma_base'=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'work_type'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'how_day_wait'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// partner
	array('table_name'	=> 'partner',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'login'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '100',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pass'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '32',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'site'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'site_descr'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'town'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'phones'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'reg_date'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'last_date'	=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'mult_proc'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'mult_click'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'active'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'charset'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'account'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'status'		=> array('type' => 'TINYINT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'work_regime'	=> array('type' => 'TINYINT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),		 
	// partner_account
	array('table_name'	=> 'partner_account',
		  'fields' 	   	=> array('id'			=> array('type' => 'BIGINT',
			   								   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'partner_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'operate'		=> array('type' => 'TINYINT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'account'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'notice'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY', 'partner_id' => 'KEY'),
		  'attr'		=> ''
		 ),		 
	// partner_click
	array('table_name'	=> 'partner_click',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'click_to_buy'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma'			=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_curr_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'suma_base'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY', 'click_to_buy' => 'KEY'),
		  'attr'		=> ''
		 ),		 
	// partner_payment
	array('table_name'	=> 'partner_payment',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'descr'		=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'multiplex'	=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',4',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'division'		=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),		 
	// partner_stat
	array('table_name'	=> 'partner_stat',
		  'fields' 	   	=> array('partner_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'ip'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'from_page'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'cookie_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('partner_id' => 'KEY', 'date_time' => 'KEY'),
		  'attr'		=> ''
		 ),		 
	// partner_stat_days
	array('table_name'	=> 'partner_stat_days',
		  'fields' 	   	=> array('partner_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'isday'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'click_all'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'click_accept'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('partner_id' => 'KEY', 'isday' => 'KEY'),
		  'attr'		=> ''
		 ),		 
	// partner_stat_month
	array('table_name'	=> 'partner_stat_month',
		  'fields' 	   	=> array('partner_id'	=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'ismonth'		=> array('type' => 'DATE',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'click_all'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'click_accept'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'pay_was_calc'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('partner_id' => 'KEY', 'ismonth' => 'KEY'),
		  'attr'		=> ''
		 ),
	// partner_stat_common
	array('table_name'	=> 'partner_stat_common',
		  'fields' 	   	=> array('isday'		=> array('type' => 'DATE',
			   								   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'part_total'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_reg'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_status0'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_status1'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_status2'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_status3'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_active'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'part_account_total'=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'click_all'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'click_accept'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'orders_all'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'orders_part'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'orders_all_sum'=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'orders_part_sum'=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'account_oper0'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'account_oper1'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'account_oper2'=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'account_oper0_sum'=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),								 
								 'account_oper1_sum'=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),								 
								 'account_oper2_sum'=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('isday' => 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// partner_block_site
	array('table_name'	=> 'partner_block_site',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								'domen'			=> array('type' => 'VARCHAR',
			   								   			 'size' => '100',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' 	=> 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// messenger
	array('table_name'	=> 'messenger',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'topic_name'	=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'charset'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '20',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' 	=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 ),
	// store_comment
	array('table_name'	=> 'store_comment',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('AUTO_INCREMENT', 'NOT NULL')
											  			 ),
								 'store_id'		=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '50',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'mess_text'	=> array('type' => 'MEDIUMTEXT',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'set_voice'	=> array('type' => 'TINYINT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'ip'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' 	=> 'PRIMARY KEY', 'store_id' => 'KEY'
								),
		  'attr'		=> ''
		 ),
	// comment_block
	array('table_name'	=> 'comment_block',
		  'fields' 	   	=> array('ip'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'date_time'	=> array('type' => 'DATETIME',
		   									   			 'size' => '',
											   			 'attr' => array('NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('ip' 	=> 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// client_rules
	array('table_name'	=> 'client_rules',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'orders_sum'	=> array('type' => 'DECIMAL',
		   									   			 'size' => ($mash+2).',2',
											   			 'attr' => array('UNSIGNED', 'NOT NULL'),
											   			 ),
								 'category_id'	=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL'),
											   			 ),
								 'set_proc'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL'),
											   			 ),
								 'set_suma'		=> array('type' => 'DECIMAL',
		   									   			 'size' => $mash.',2',
											   			 'attr' => array('NOT NULL')
											   			 )
							   ),
		  'indexes'	   	=> array('id' 	=> 'PRIMARY KEY'),
		  'attr'		=> ''
		 ),
	// provider
	array('table_name'	=> 'provider',
		  'fields' 	   	=> array('id'			=> array('type' => 'INT',
			   								   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 ),
								 'name'			=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'manager'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'email'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '75',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'phone'		=> array('type' => 'VARCHAR',
		   									   			 'size' => '255',
											   			 'attr' => array('NOT NULL')
											  			 ),
								 'pos'			=> array('type' => 'INT',
		   									   			 'size' => '',
											   			 'attr' => array('UNSIGNED', 'NOT NULL')
											  			 )
							   ),
		  'indexes'	   	=> array('id' 	=> 'PRIMARY KEY'
								),
		  'attr'		=> ''
		 )		 
	);
		
//print_r($gTables);	
   
?>